Unit CRT;


(**************************************************************************)
(*                                                                        *)
(*  CRT 1.0 - a GNU Pascal Unit to achive as much compatibility to        *)
(*            Borland Pascal's CRT as possible and reasonable             *)
(*            (a goal not yet reached).                                   *)
(*                                                                        *)
(*  Copyright (C) 1997  Peter Gerwinski, Essen, Germany                   *)
(*                      <peter.gerwinski@uni-essen.de>                    *)
(*                      http://home.pages.de/~peter.gerwinski/            *)
(*                                                                        *)
(*  This library is a free library; you can redistribute and/or modify    *)
(*  it under the terms of the GNU Library General Public License,         *)
(*  version 2, as published by the Free Software Foundation.              *)
(*                                                                        *)
(*  This library is distributed in the hope that it will be useful,       *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Library General Public License for more details.                  *)
(*                                                                        *)
(*  You should have received a copy of the GNU Library General Public     *)
(*  License along with this library (see the file COPYING.LIB); if not,   *)
(*  write to the Free Software Foundation, Inc., 675 Mass Ave,            *)
(*  Cambridge, MA 02139, USA.                                             *)
(*                                                                        *)
(**************************************************************************)


Interface


(* Warnings, e.g. about remaining incompatibilities, *)
(* are given as comments starting with "!!!".        *)


(*$ifdef __GPC__ *)

uses
  System;  (* !!! Must be used explicitly *)

(*$endif *)


(*** Screen color constants ***)

Const
  black     = 0;        darkgray     =  8;
  blue      = 1;        lightblue    =  9;
  green     = 2;        lightgreen   = 10;
  cyan      = 3;        lightcyan    = 11;
  red       = 4;        lightred     = 12;
  magenta   = 5;        lightmagenta = 13;
  brown     = 6;        yellow       = 14;
  lightgray = 7;        white        = 15;

  blink = 128;


(*** Screen modes ***)

Const
  LastMode = -1;  (* !!! A variable in Borland Pascal *)
  bw40 = 0;
  co40 = 1;
  bw80 = 2;
  co80 = 3;
  mono = 7;
  font8x8 = 64 - co80;  (* !!! Works only in combination with co80 *)
  c40 = co40;           (* Turbo Pascal 3.0 compatibility *)
  c80 = co80;


(* Screen access *)

Var
  DirectVideo: asmname '_p_directvideo' Boolean;
  CheckSnow: Boolean value true;  (* !!! present, but ignored *)


(* !!! Procedure AssignCrt is missing. *)

Procedure TextMode ( Mode: Integer ); C;

Procedure GotoXY ( x, y: Integer ); C;
(* !!! "x, y: Byte" in Borland Pascal.      *)
(* Similar things hold for most procedures. *)

Procedure TextAttr ( Attr: Integer ); C;
Function GetTextAttr: Integer;
(* !!! a Byte variable in BP *)

Function WhereX: Integer; C;
Function WhereY: Integer; C;

Procedure ClrScr; C;
Procedure ClrEol; C;
Procedure InsLine; C;
Procedure DelLine; C;
Procedure Window ( x1, y1, x2, y2: Integer ); C;

Function WindMin: Word;  (* !!! Variables in BP *)
Function WindMax: Word;

Procedure TextColor ( color: Byte ); C;
Procedure TextBackground ( color: Byte ); C;
Procedure HighVideo; C;
Procedure LowVideo; C;
Procedure NormVideo; C;


(*** Keyboard ***)

Var
  CheckBreak: Boolean value true;  (* !!! present but ignored *)
  CheckEOF: Boolean value false;

Function KeyPressed: Boolean; AsmName '_conio_kbhit';
Function ReadKey: Char; AsmName 'getch';


(*** Miscellaneous ***)

Procedure Delay ( ms: Word ); C;
Procedure Sound ( Hz: Word ); C;
Procedure NoSound;


Implementation


Type


TextInfoRec = record
  WinLeft, WinTop, WinRight, WinBottom,
    Attribute, NormAttr, CurrMode,
    ScreenHeight, ScreenWidth, CurX, CurY: Byte;
end (* TextInfoRec *);


Procedure GetTextInfo ( Var TextInfo: TextInfoRec ); C;


Function GetTextAttr: Byte;

Var
  TextInfo: TextInfoRec;

begin (* GetTextAttr *)
  GetTextInfo ( TextInfo );
  GetTextAttr:= TextInfo.Attribute;
end (* GetTextAttr *);


Function WindMin: Word;

Var
  TextInfo: TextInfoRec;

begin (* WindMin *)
  GetTextInfo ( TextInfo );
  with TextInfo do
    WindMin:= WinLeft + 256 * WinTop;
end (* WindMin *);


Function WindMax: Word;

Var
  TextInfo: TextInfoRec;

begin (* WindMax *)
  GetTextInfo ( TextInfo );
  with TextInfo do
    WindMax:= WinRight + 256 * WinBottom;
end (* WindMax *);


Procedure NoSound;

begin (* NoSound *)
  Sound ( 0 );
end (* NoSound *);


begin
  DirectVideo:= true;
end.

